<?php

namespace Eater\Glim\Model\Base;

use \Exception;
use \PDO;
use Eater\Glim\Model\EmailAddress as ChildEmailAddress;
use Eater\Glim\Model\EmailAddressQuery as ChildEmailAddressQuery;
use Eater\Glim\Model\EmailMessage as ChildEmailMessage;
use Eater\Glim\Model\EmailMessageQuery as ChildEmailMessageQuery;
use Eater\Glim\Model\User as ChildUser;
use Eater\Glim\Model\UserQuery as ChildUserQuery;
use Eater\Glim\Model\Map\EmailAddressTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\LogicException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;

/**
 * Base class that represents a row from the 'email_address' table.
 *
 *
 *
* @package    propel.generator..Base
*/
abstract class EmailAddress implements ActiveRecordInterface
{
    /**
     * TableMap class name
     */
    const TABLE_MAP = '\\Eater\\Glim\\Model\\Map\\EmailAddressTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var boolean
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var boolean
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = array();

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = array();

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the verified field.
     * Note: this column has a database default value of: false
     * @var        boolean
     */
    protected $verified;

    /**
     * The value for the verification field.
     * @var        string
     */
    protected $verification;

    /**
     * The value for the address field.
     * @var        string
     */
    protected $address;

    /**
     * The value for the owner field.
     * @var        int
     */
    protected $owner;

    /**
     * @var        ChildUser
     */
    protected $aUserRelatedByOwner;

    /**
     * @var        ObjectCollection|ChildUser[] Collection to store aggregation of ChildUser objects.
     */
    protected $collUsersRelatedByEmail;
    protected $collUsersRelatedByEmailPartial;

    /**
     * @var        ObjectCollection|ChildEmailMessage[] Collection to store aggregation of ChildEmailMessage objects.
     */
    protected $collEmailMessagesRelatedByRecipient;
    protected $collEmailMessagesRelatedByRecipientPartial;

    /**
     * @var        ObjectCollection|ChildEmailMessage[] Collection to store aggregation of ChildEmailMessage objects.
     */
    protected $collEmailMessagesRelatedBySender;
    protected $collEmailMessagesRelatedBySenderPartial;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var boolean
     */
    protected $alreadyInSave = false;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|ChildUser[]
     */
    protected $usersRelatedByEmailScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|ChildEmailMessage[]
     */
    protected $emailMessagesRelatedByRecipientScheduledForDeletion = null;

    /**
     * An array of objects scheduled for deletion.
     * @var ObjectCollection|ChildEmailMessage[]
     */
    protected $emailMessagesRelatedBySenderScheduledForDeletion = null;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues()
    {
        $this->verified = false;
    }

    /**
     * Initializes internal state of Eater\Glim\Model\Base\EmailAddress object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return boolean True if the object has been modified.
     */
    public function isModified()
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param  string  $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return boolean True if $col has been modified.
     */
    public function isColumnModified($col)
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns()
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return boolean true, if the object has never been persisted.
     */
    public function isNew()
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param boolean $b the state of the object.
     */
    public function setNew($b)
    {
        $this->new = (boolean) $b;
    }

    /**
     * Whether this object has been deleted.
     * @return boolean The deleted state of this object.
     */
    public function isDeleted()
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param  boolean $b The deleted state of this object.
     * @return void
     */
    public function setDeleted($b)
    {
        $this->deleted = (boolean) $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param  string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified($col = null)
    {
        if (null !== $col) {
            if (isset($this->modifiedColumns[$col])) {
                unset($this->modifiedColumns[$col]);
            }
        } else {
            $this->modifiedColumns = array();
        }
    }

    /**
     * Compares this with another <code>EmailAddress</code> instance.  If
     * <code>obj</code> is an instance of <code>EmailAddress</code>, delegates to
     * <code>equals(EmailAddress)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param  mixed   $obj The object to compare to.
     * @return boolean Whether equal to the object specified.
     */
    public function equals($obj)
    {
        if (!$obj instanceof static) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey() || null === $obj->getPrimaryKey()) {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns()
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param  string  $name The virtual column name
     * @return boolean
     */
    public function hasVirtualColumn($name)
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param  string $name The virtual column name
     * @return mixed
     *
     * @throws PropelException
     */
    public function getVirtualColumn($name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of inexistent virtual column %s.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name  The virtual column name
     * @param mixed  $value The value to give to the virtual column
     *
     * @return $this|EmailAddress The current object, for fluid interface
     */
    public function setVirtualColumn($name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param  string  $msg
     * @param  int     $priority One of the Propel::LOG_* logging levels
     * @return boolean
     */
    protected function log($msg, $priority = Propel::LOG_INFO)
    {
        return Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param  mixed   $parser                 A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param  boolean $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @return string  The exported data
     */
    public function exportTo($parser, $includeLazyLoadColumns = true)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray(TableMap::TYPE_PHPNAME, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     */
    public function __sleep()
    {
        $this->clearAllReferences();

        return array_keys(get_object_vars($this));
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Get the [verified] column value.
     *
     * @return boolean
     */
    public function getVerified()
    {
        return $this->verified;
    }

    /**
     * Get the [verified] column value.
     *
     * @return boolean
     */
    public function isVerified()
    {
        return $this->getVerified();
    }

    /**
     * Get the [verification] column value.
     *
     * @return string
     */
    public function getVerification()
    {
        return $this->verification;
    }

    /**
     * Get the [address] column value.
     *
     * @return string
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Get the [owner] column value.
     *
     * @return int
     */
    public function getOwner()
    {
        return $this->owner;
    }

    /**
     * Set the value of [id] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[EmailAddressTableMap::COL_ID] = true;
        }

        return $this;
    } // setId()

    /**
     * Sets the value of the [verified] column.
     * Non-boolean arguments are converted using the following rules:
     *   * 1, '1', 'true',  'on',  and 'yes' are converted to boolean true
     *   * 0, '0', 'false', 'off', and 'no'  are converted to boolean false
     * Check on string values is case insensitive (so 'FaLsE' is seen as 'false').
     *
     * @param  boolean|integer|string $v The new value
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function setVerified($v)
    {
        if ($v !== null) {
            if (is_string($v)) {
                $v = in_array(strtolower($v), array('false', 'off', '-', 'no', 'n', '0', '')) ? false : true;
            } else {
                $v = (boolean) $v;
            }
        }

        if ($this->verified !== $v) {
            $this->verified = $v;
            $this->modifiedColumns[EmailAddressTableMap::COL_VERIFIED] = true;
        }

        return $this;
    } // setVerified()

    /**
     * Set the value of [verification] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function setVerification($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->verification !== $v) {
            $this->verification = $v;
            $this->modifiedColumns[EmailAddressTableMap::COL_VERIFICATION] = true;
        }

        return $this;
    } // setVerification()

    /**
     * Set the value of [address] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function setAddress($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->address !== $v) {
            $this->address = $v;
            $this->modifiedColumns[EmailAddressTableMap::COL_ADDRESS] = true;
        }

        return $this;
    } // setAddress()

    /**
     * Set the value of [owner] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function setOwner($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->owner !== $v) {
            $this->owner = $v;
            $this->modifiedColumns[EmailAddressTableMap::COL_OWNER] = true;
        }

        if ($this->aUserRelatedByOwner !== null && $this->aUserRelatedByOwner->getId() !== $v) {
            $this->aUserRelatedByOwner = null;
        }

        return $this;
    } // setOwner()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->verified !== false) {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array   $row       The row returned by DataFetcher->fetch().
     * @param int     $startcol  0-based offset column which indicates which restultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @param string  $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false, $indexType = TableMap::TYPE_NUM)
    {
        try {

            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : EmailAddressTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : EmailAddressTableMap::translateFieldName('Verified', TableMap::TYPE_PHPNAME, $indexType)];
            $this->verified = (null !== $col) ? (boolean) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : EmailAddressTableMap::translateFieldName('Verification', TableMap::TYPE_PHPNAME, $indexType)];
            $this->verification = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : EmailAddressTableMap::translateFieldName('Address', TableMap::TYPE_PHPNAME, $indexType)];
            $this->address = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : EmailAddressTableMap::translateFieldName('Owner', TableMap::TYPE_PHPNAME, $indexType)];
            $this->owner = (null !== $col) ? (int) $col : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 5; // 5 = EmailAddressTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException(sprintf('Error populating %s object', '\\Eater\\Glim\\Model\\EmailAddress'), 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {
        if ($this->aUserRelatedByOwner !== null && $this->owner !== $this->aUserRelatedByOwner->getId()) {
            $this->aUserRelatedByOwner = null;
        }
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param      boolean $deep (optional) Whether to also de-associated any related objects.
     * @param      ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildEmailAddressQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

            $this->aUserRelatedByOwner = null;
            $this->collUsersRelatedByEmail = null;

            $this->collEmailMessagesRelatedByRecipient = null;

            $this->collEmailMessagesRelatedBySender = null;

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      ConnectionInterface $con
     * @return void
     * @throws PropelException
     * @see EmailAddress::setDeleted()
     * @see EmailAddress::isDeleted()
     */
    public function delete(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        $con->transaction(function () use ($con) {
            $deleteQuery = ChildEmailAddressQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $this->setDeleted(true);
            }
        });
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see doSave()
     */
    public function save(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(EmailAddressTableMap::DATABASE_NAME);
        }

        return $con->transaction(function () use ($con) {
            $isInsert = $this->isNew();
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                EmailAddressTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }

            return $affectedRows;
        });
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            // We call the save method on the following object(s) if they
            // were passed to this object by their corresponding set
            // method.  This object relates to these object(s) by a
            // foreign key reference.

            if ($this->aUserRelatedByOwner !== null) {
                if ($this->aUserRelatedByOwner->isModified() || $this->aUserRelatedByOwner->isNew()) {
                    $affectedRows += $this->aUserRelatedByOwner->save($con);
                }
                $this->setUserRelatedByOwner($this->aUserRelatedByOwner);
            }

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                    $affectedRows += 1;
                } else {
                    $affectedRows += $this->doUpdate($con);
                }
                $this->resetModified();
            }

            if ($this->usersRelatedByEmailScheduledForDeletion !== null) {
                if (!$this->usersRelatedByEmailScheduledForDeletion->isEmpty()) {
                    foreach ($this->usersRelatedByEmailScheduledForDeletion as $userRelatedByEmail) {
                        // need to save related object because we set the relation to null
                        $userRelatedByEmail->save($con);
                    }
                    $this->usersRelatedByEmailScheduledForDeletion = null;
                }
            }

            if ($this->collUsersRelatedByEmail !== null) {
                foreach ($this->collUsersRelatedByEmail as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->emailMessagesRelatedByRecipientScheduledForDeletion !== null) {
                if (!$this->emailMessagesRelatedByRecipientScheduledForDeletion->isEmpty()) {
                    foreach ($this->emailMessagesRelatedByRecipientScheduledForDeletion as $emailMessageRelatedByRecipient) {
                        // need to save related object because we set the relation to null
                        $emailMessageRelatedByRecipient->save($con);
                    }
                    $this->emailMessagesRelatedByRecipientScheduledForDeletion = null;
                }
            }

            if ($this->collEmailMessagesRelatedByRecipient !== null) {
                foreach ($this->collEmailMessagesRelatedByRecipient as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            if ($this->emailMessagesRelatedBySenderScheduledForDeletion !== null) {
                if (!$this->emailMessagesRelatedBySenderScheduledForDeletion->isEmpty()) {
                    foreach ($this->emailMessagesRelatedBySenderScheduledForDeletion as $emailMessageRelatedBySender) {
                        // need to save related object because we set the relation to null
                        $emailMessageRelatedBySender->save($con);
                    }
                    $this->emailMessagesRelatedBySenderScheduledForDeletion = null;
                }
            }

            if ($this->collEmailMessagesRelatedBySender !== null) {
                foreach ($this->collEmailMessagesRelatedBySender as $referrerFK) {
                    if (!$referrerFK->isDeleted() && ($referrerFK->isNew() || $referrerFK->isModified())) {
                        $affectedRows += $referrerFK->save($con);
                    }
                }
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @throws PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[EmailAddressTableMap::COL_ID] = true;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . EmailAddressTableMap::COL_ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(EmailAddressTableMap::COL_ID)) {
            $modifiedColumns[':p' . $index++]  = 'id';
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_VERIFIED)) {
            $modifiedColumns[':p' . $index++]  = 'verified';
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_VERIFICATION)) {
            $modifiedColumns[':p' . $index++]  = 'verification';
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_ADDRESS)) {
            $modifiedColumns[':p' . $index++]  = 'address';
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_OWNER)) {
            $modifiedColumns[':p' . $index++]  = 'owner';
        }

        $sql = sprintf(
            'INSERT INTO email_address (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case 'id':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case 'verified':
                        $stmt->bindValue($identifier, $this->verified, PDO::PARAM_BOOL);
                        break;
                    case 'verification':
                        $stmt->bindValue($identifier, $this->verification, PDO::PARAM_STR);
                        break;
                    case 'address':
                        $stmt->bindValue($identifier, $this->address, PDO::PARAM_STR);
                        break;
                    case 'owner':
                        $stmt->bindValue($identifier, $this->owner, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', 0, $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @return Integer Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName($name, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = EmailAddressTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getVerified();
                break;
            case 2:
                return $this->getVerification();
                break;
            case 3:
                return $this->getAddress();
                break;
            case 4:
                return $this->getOwner();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     * @param     boolean $includeForeignObjects (optional) Whether to include hydrated related objects. Default to FALSE.
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = TableMap::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array(), $includeForeignObjects = false)
    {

        if (isset($alreadyDumpedObjects['EmailAddress'][$this->hashCode()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['EmailAddress'][$this->hashCode()] = true;
        $keys = EmailAddressTableMap::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getVerified(),
            $keys[2] => $this->getVerification(),
            $keys[3] => $this->getAddress(),
            $keys[4] => $this->getOwner(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }

        if ($includeForeignObjects) {
            if (null !== $this->aUserRelatedByOwner) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'user';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'user';
                        break;
                    default:
                        $key = 'User';
                }

                $result[$key] = $this->aUserRelatedByOwner->toArray($keyType, $includeLazyLoadColumns,  $alreadyDumpedObjects, true);
            }
            if (null !== $this->collUsersRelatedByEmail) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'users';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'users';
                        break;
                    default:
                        $key = 'Users';
                }

                $result[$key] = $this->collUsersRelatedByEmail->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collEmailMessagesRelatedByRecipient) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'emailMessages';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'email_messages';
                        break;
                    default:
                        $key = 'EmailMessages';
                }

                $result[$key] = $this->collEmailMessagesRelatedByRecipient->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
            if (null !== $this->collEmailMessagesRelatedBySender) {

                switch ($keyType) {
                    case TableMap::TYPE_CAMELNAME:
                        $key = 'emailMessages';
                        break;
                    case TableMap::TYPE_FIELDNAME:
                        $key = 'email_messages';
                        break;
                    default:
                        $key = 'EmailMessages';
                }

                $result[$key] = $this->collEmailMessagesRelatedBySender->toArray(null, false, $keyType, $includeLazyLoadColumns, $alreadyDumpedObjects);
            }
        }

        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param  string $name
     * @param  mixed  $value field value
     * @param  string $type The type of fieldname the $name is of:
     *                one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                Defaults to TableMap::TYPE_PHPNAME.
     * @return $this|\Eater\Glim\Model\EmailAddress
     */
    public function setByName($name, $value, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = EmailAddressTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param  int $pos position in xml schema
     * @param  mixed $value field value
     * @return $this|\Eater\Glim\Model\EmailAddress
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setVerified($value);
                break;
            case 2:
                $this->setVerification($value);
                break;
            case 3:
                $this->setAddress($value);
                break;
            case 4:
                $this->setOwner($value);
                break;
        } // switch()

        return $this;
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = EmailAddressTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setId($arr[$keys[0]]);
        }
        if (array_key_exists($keys[1], $arr)) {
            $this->setVerified($arr[$keys[1]]);
        }
        if (array_key_exists($keys[2], $arr)) {
            $this->setVerification($arr[$keys[2]]);
        }
        if (array_key_exists($keys[3], $arr)) {
            $this->setAddress($arr[$keys[3]]);
        }
        if (array_key_exists($keys[4], $arr)) {
            $this->setOwner($arr[$keys[4]]);
        }
    }

     /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     * @param string $keyType The type of keys the array uses.
     *
     * @return $this|\Eater\Glim\Model\EmailAddress The current object, for fluid interface
     */
    public function importFrom($parser, $data, $keyType = TableMap::TYPE_PHPNAME)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), $keyType);

        return $this;
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(EmailAddressTableMap::DATABASE_NAME);

        if ($this->isColumnModified(EmailAddressTableMap::COL_ID)) {
            $criteria->add(EmailAddressTableMap::COL_ID, $this->id);
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_VERIFIED)) {
            $criteria->add(EmailAddressTableMap::COL_VERIFIED, $this->verified);
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_VERIFICATION)) {
            $criteria->add(EmailAddressTableMap::COL_VERIFICATION, $this->verification);
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_ADDRESS)) {
            $criteria->add(EmailAddressTableMap::COL_ADDRESS, $this->address);
        }
        if ($this->isColumnModified(EmailAddressTableMap::COL_OWNER)) {
            $criteria->add(EmailAddressTableMap::COL_OWNER, $this->owner);
        }

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @throws LogicException if no primary key is defined
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = ChildEmailAddressQuery::create();
        $criteria->add(EmailAddressTableMap::COL_ID, $this->id);

        return $criteria;
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int Hashcode
     */
    public function hashCode()
    {
        $validPk = null !== $this->getId();

        $validPrimaryKeyFKs = 0;
        $primaryKeyFKs = [];

        if ($validPk) {
            return crc32(json_encode($this->getPrimaryKey(), JSON_UNESCAPED_UNICODE));
        } elseif ($validPrimaryKeyFKs) {
            return crc32(json_encode($primaryKeyFKs, JSON_UNESCAPED_UNICODE));
        }

        return spl_object_hash($this);
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param       int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {
        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of \Eater\Glim\Model\EmailAddress (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param      boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setVerified($this->getVerified());
        $copyObj->setVerification($this->getVerification());
        $copyObj->setAddress($this->getAddress());
        $copyObj->setOwner($this->getOwner());

        if ($deepCopy) {
            // important: temporarily setNew(false) because this affects the behavior of
            // the getter/setter methods for fkey referrer objects.
            $copyObj->setNew(false);

            foreach ($this->getUsersRelatedByEmail() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addUserRelatedByEmail($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getEmailMessagesRelatedByRecipient() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addEmailMessageRelatedByRecipient($relObj->copy($deepCopy));
                }
            }

            foreach ($this->getEmailMessagesRelatedBySender() as $relObj) {
                if ($relObj !== $this) {  // ensure that we don't try to copy a reference to ourselves
                    $copyObj->addEmailMessageRelatedBySender($relObj->copy($deepCopy));
                }
            }

        } // if ($deepCopy)

        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param  boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return \Eater\Glim\Model\EmailAddress Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Declares an association between this object and a ChildUser object.
     *
     * @param  ChildUser $v
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     * @throws PropelException
     */
    public function setUserRelatedByOwner(ChildUser $v = null)
    {
        if ($v === null) {
            $this->setOwner(NULL);
        } else {
            $this->setOwner($v->getId());
        }

        $this->aUserRelatedByOwner = $v;

        // Add binding for other direction of this n:n relationship.
        // If this object has already been added to the ChildUser object, it will not be re-added.
        if ($v !== null) {
            $v->addEmailAddressRelatedByOwner($this);
        }


        return $this;
    }


    /**
     * Get the associated ChildUser object
     *
     * @param  ConnectionInterface $con Optional Connection object.
     * @return ChildUser The associated ChildUser object.
     * @throws PropelException
     */
    public function getUserRelatedByOwner(ConnectionInterface $con = null)
    {
        if ($this->aUserRelatedByOwner === null && ($this->owner !== null)) {
            $this->aUserRelatedByOwner = ChildUserQuery::create()->findPk($this->owner, $con);
            /* The following can be used additionally to
                guarantee the related object contains a reference
                to this object.  This level of coupling may, however, be
                undesirable since it could result in an only partially populated collection
                in the referenced object.
                $this->aUserRelatedByOwner->addEmailAddressesRelatedByOwner($this);
             */
        }

        return $this->aUserRelatedByOwner;
    }


    /**
     * Initializes a collection based on the name of a relation.
     * Avoids crafting an 'init[$relationName]s' method name
     * that wouldn't work when StandardEnglishPluralizer is used.
     *
     * @param      string $relationName The name of the relation to initialize
     * @return void
     */
    public function initRelation($relationName)
    {
        if ('UserRelatedByEmail' == $relationName) {
            return $this->initUsersRelatedByEmail();
        }
        if ('EmailMessageRelatedByRecipient' == $relationName) {
            return $this->initEmailMessagesRelatedByRecipient();
        }
        if ('EmailMessageRelatedBySender' == $relationName) {
            return $this->initEmailMessagesRelatedBySender();
        }
    }

    /**
     * Clears out the collUsersRelatedByEmail collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addUsersRelatedByEmail()
     */
    public function clearUsersRelatedByEmail()
    {
        $this->collUsersRelatedByEmail = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Reset is the collUsersRelatedByEmail collection loaded partially.
     */
    public function resetPartialUsersRelatedByEmail($v = true)
    {
        $this->collUsersRelatedByEmailPartial = $v;
    }

    /**
     * Initializes the collUsersRelatedByEmail collection.
     *
     * By default this just sets the collUsersRelatedByEmail collection to an empty array (like clearcollUsersRelatedByEmail());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param      boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initUsersRelatedByEmail($overrideExisting = true)
    {
        if (null !== $this->collUsersRelatedByEmail && !$overrideExisting) {
            return;
        }
        $this->collUsersRelatedByEmail = new ObjectCollection();
        $this->collUsersRelatedByEmail->setModel('\Eater\Glim\Model\User');
    }

    /**
     * Gets an array of ChildUser objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildEmailAddress is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @return ObjectCollection|ChildUser[] List of ChildUser objects
     * @throws PropelException
     */
    public function getUsersRelatedByEmail(Criteria $criteria = null, ConnectionInterface $con = null)
    {
        $partial = $this->collUsersRelatedByEmailPartial && !$this->isNew();
        if (null === $this->collUsersRelatedByEmail || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collUsersRelatedByEmail) {
                // return empty collection
                $this->initUsersRelatedByEmail();
            } else {
                $collUsersRelatedByEmail = ChildUserQuery::create(null, $criteria)
                    ->filterByEmailAddressRelatedByEmail($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collUsersRelatedByEmailPartial && count($collUsersRelatedByEmail)) {
                        $this->initUsersRelatedByEmail(false);

                        foreach ($collUsersRelatedByEmail as $obj) {
                            if (false == $this->collUsersRelatedByEmail->contains($obj)) {
                                $this->collUsersRelatedByEmail->append($obj);
                            }
                        }

                        $this->collUsersRelatedByEmailPartial = true;
                    }

                    return $collUsersRelatedByEmail;
                }

                if ($partial && $this->collUsersRelatedByEmail) {
                    foreach ($this->collUsersRelatedByEmail as $obj) {
                        if ($obj->isNew()) {
                            $collUsersRelatedByEmail[] = $obj;
                        }
                    }
                }

                $this->collUsersRelatedByEmail = $collUsersRelatedByEmail;
                $this->collUsersRelatedByEmailPartial = false;
            }
        }

        return $this->collUsersRelatedByEmail;
    }

    /**
     * Sets a collection of ChildUser objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param      Collection $usersRelatedByEmail A Propel collection.
     * @param      ConnectionInterface $con Optional connection object
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function setUsersRelatedByEmail(Collection $usersRelatedByEmail, ConnectionInterface $con = null)
    {
        /** @var ChildUser[] $usersRelatedByEmailToDelete */
        $usersRelatedByEmailToDelete = $this->getUsersRelatedByEmail(new Criteria(), $con)->diff($usersRelatedByEmail);


        $this->usersRelatedByEmailScheduledForDeletion = $usersRelatedByEmailToDelete;

        foreach ($usersRelatedByEmailToDelete as $userRelatedByEmailRemoved) {
            $userRelatedByEmailRemoved->setEmailAddressRelatedByEmail(null);
        }

        $this->collUsersRelatedByEmail = null;
        foreach ($usersRelatedByEmail as $userRelatedByEmail) {
            $this->addUserRelatedByEmail($userRelatedByEmail);
        }

        $this->collUsersRelatedByEmail = $usersRelatedByEmail;
        $this->collUsersRelatedByEmailPartial = false;

        return $this;
    }

    /**
     * Returns the number of related User objects.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct
     * @param      ConnectionInterface $con
     * @return int             Count of related User objects.
     * @throws PropelException
     */
    public function countUsersRelatedByEmail(Criteria $criteria = null, $distinct = false, ConnectionInterface $con = null)
    {
        $partial = $this->collUsersRelatedByEmailPartial && !$this->isNew();
        if (null === $this->collUsersRelatedByEmail || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collUsersRelatedByEmail) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getUsersRelatedByEmail());
            }

            $query = ChildUserQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByEmailAddressRelatedByEmail($this)
                ->count($con);
        }

        return count($this->collUsersRelatedByEmail);
    }

    /**
     * Method called to associate a ChildUser object to this object
     * through the ChildUser foreign key attribute.
     *
     * @param  ChildUser $l ChildUser
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function addUserRelatedByEmail(ChildUser $l)
    {
        if ($this->collUsersRelatedByEmail === null) {
            $this->initUsersRelatedByEmail();
            $this->collUsersRelatedByEmailPartial = true;
        }

        if (!$this->collUsersRelatedByEmail->contains($l)) {
            $this->doAddUserRelatedByEmail($l);
        }

        return $this;
    }

    /**
     * @param ChildUser $userRelatedByEmail The ChildUser object to add.
     */
    protected function doAddUserRelatedByEmail(ChildUser $userRelatedByEmail)
    {
        $this->collUsersRelatedByEmail[]= $userRelatedByEmail;
        $userRelatedByEmail->setEmailAddressRelatedByEmail($this);
    }

    /**
     * @param  ChildUser $userRelatedByEmail The ChildUser object to remove.
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function removeUserRelatedByEmail(ChildUser $userRelatedByEmail)
    {
        if ($this->getUsersRelatedByEmail()->contains($userRelatedByEmail)) {
            $pos = $this->collUsersRelatedByEmail->search($userRelatedByEmail);
            $this->collUsersRelatedByEmail->remove($pos);
            if (null === $this->usersRelatedByEmailScheduledForDeletion) {
                $this->usersRelatedByEmailScheduledForDeletion = clone $this->collUsersRelatedByEmail;
                $this->usersRelatedByEmailScheduledForDeletion->clear();
            }
            $this->usersRelatedByEmailScheduledForDeletion[]= $userRelatedByEmail;
            $userRelatedByEmail->setEmailAddressRelatedByEmail(null);
        }

        return $this;
    }

    /**
     * Clears out the collEmailMessagesRelatedByRecipient collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addEmailMessagesRelatedByRecipient()
     */
    public function clearEmailMessagesRelatedByRecipient()
    {
        $this->collEmailMessagesRelatedByRecipient = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Reset is the collEmailMessagesRelatedByRecipient collection loaded partially.
     */
    public function resetPartialEmailMessagesRelatedByRecipient($v = true)
    {
        $this->collEmailMessagesRelatedByRecipientPartial = $v;
    }

    /**
     * Initializes the collEmailMessagesRelatedByRecipient collection.
     *
     * By default this just sets the collEmailMessagesRelatedByRecipient collection to an empty array (like clearcollEmailMessagesRelatedByRecipient());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param      boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initEmailMessagesRelatedByRecipient($overrideExisting = true)
    {
        if (null !== $this->collEmailMessagesRelatedByRecipient && !$overrideExisting) {
            return;
        }
        $this->collEmailMessagesRelatedByRecipient = new ObjectCollection();
        $this->collEmailMessagesRelatedByRecipient->setModel('\Eater\Glim\Model\EmailMessage');
    }

    /**
     * Gets an array of ChildEmailMessage objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildEmailAddress is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @return ObjectCollection|ChildEmailMessage[] List of ChildEmailMessage objects
     * @throws PropelException
     */
    public function getEmailMessagesRelatedByRecipient(Criteria $criteria = null, ConnectionInterface $con = null)
    {
        $partial = $this->collEmailMessagesRelatedByRecipientPartial && !$this->isNew();
        if (null === $this->collEmailMessagesRelatedByRecipient || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collEmailMessagesRelatedByRecipient) {
                // return empty collection
                $this->initEmailMessagesRelatedByRecipient();
            } else {
                $collEmailMessagesRelatedByRecipient = ChildEmailMessageQuery::create(null, $criteria)
                    ->filterByRecipientEmailAddress($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collEmailMessagesRelatedByRecipientPartial && count($collEmailMessagesRelatedByRecipient)) {
                        $this->initEmailMessagesRelatedByRecipient(false);

                        foreach ($collEmailMessagesRelatedByRecipient as $obj) {
                            if (false == $this->collEmailMessagesRelatedByRecipient->contains($obj)) {
                                $this->collEmailMessagesRelatedByRecipient->append($obj);
                            }
                        }

                        $this->collEmailMessagesRelatedByRecipientPartial = true;
                    }

                    return $collEmailMessagesRelatedByRecipient;
                }

                if ($partial && $this->collEmailMessagesRelatedByRecipient) {
                    foreach ($this->collEmailMessagesRelatedByRecipient as $obj) {
                        if ($obj->isNew()) {
                            $collEmailMessagesRelatedByRecipient[] = $obj;
                        }
                    }
                }

                $this->collEmailMessagesRelatedByRecipient = $collEmailMessagesRelatedByRecipient;
                $this->collEmailMessagesRelatedByRecipientPartial = false;
            }
        }

        return $this->collEmailMessagesRelatedByRecipient;
    }

    /**
     * Sets a collection of ChildEmailMessage objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param      Collection $emailMessagesRelatedByRecipient A Propel collection.
     * @param      ConnectionInterface $con Optional connection object
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function setEmailMessagesRelatedByRecipient(Collection $emailMessagesRelatedByRecipient, ConnectionInterface $con = null)
    {
        /** @var ChildEmailMessage[] $emailMessagesRelatedByRecipientToDelete */
        $emailMessagesRelatedByRecipientToDelete = $this->getEmailMessagesRelatedByRecipient(new Criteria(), $con)->diff($emailMessagesRelatedByRecipient);


        $this->emailMessagesRelatedByRecipientScheduledForDeletion = $emailMessagesRelatedByRecipientToDelete;

        foreach ($emailMessagesRelatedByRecipientToDelete as $emailMessageRelatedByRecipientRemoved) {
            $emailMessageRelatedByRecipientRemoved->setRecipientEmailAddress(null);
        }

        $this->collEmailMessagesRelatedByRecipient = null;
        foreach ($emailMessagesRelatedByRecipient as $emailMessageRelatedByRecipient) {
            $this->addEmailMessageRelatedByRecipient($emailMessageRelatedByRecipient);
        }

        $this->collEmailMessagesRelatedByRecipient = $emailMessagesRelatedByRecipient;
        $this->collEmailMessagesRelatedByRecipientPartial = false;

        return $this;
    }

    /**
     * Returns the number of related EmailMessage objects.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct
     * @param      ConnectionInterface $con
     * @return int             Count of related EmailMessage objects.
     * @throws PropelException
     */
    public function countEmailMessagesRelatedByRecipient(Criteria $criteria = null, $distinct = false, ConnectionInterface $con = null)
    {
        $partial = $this->collEmailMessagesRelatedByRecipientPartial && !$this->isNew();
        if (null === $this->collEmailMessagesRelatedByRecipient || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collEmailMessagesRelatedByRecipient) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getEmailMessagesRelatedByRecipient());
            }

            $query = ChildEmailMessageQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterByRecipientEmailAddress($this)
                ->count($con);
        }

        return count($this->collEmailMessagesRelatedByRecipient);
    }

    /**
     * Method called to associate a ChildEmailMessage object to this object
     * through the ChildEmailMessage foreign key attribute.
     *
     * @param  ChildEmailMessage $l ChildEmailMessage
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function addEmailMessageRelatedByRecipient(ChildEmailMessage $l)
    {
        if ($this->collEmailMessagesRelatedByRecipient === null) {
            $this->initEmailMessagesRelatedByRecipient();
            $this->collEmailMessagesRelatedByRecipientPartial = true;
        }

        if (!$this->collEmailMessagesRelatedByRecipient->contains($l)) {
            $this->doAddEmailMessageRelatedByRecipient($l);
        }

        return $this;
    }

    /**
     * @param ChildEmailMessage $emailMessageRelatedByRecipient The ChildEmailMessage object to add.
     */
    protected function doAddEmailMessageRelatedByRecipient(ChildEmailMessage $emailMessageRelatedByRecipient)
    {
        $this->collEmailMessagesRelatedByRecipient[]= $emailMessageRelatedByRecipient;
        $emailMessageRelatedByRecipient->setRecipientEmailAddress($this);
    }

    /**
     * @param  ChildEmailMessage $emailMessageRelatedByRecipient The ChildEmailMessage object to remove.
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function removeEmailMessageRelatedByRecipient(ChildEmailMessage $emailMessageRelatedByRecipient)
    {
        if ($this->getEmailMessagesRelatedByRecipient()->contains($emailMessageRelatedByRecipient)) {
            $pos = $this->collEmailMessagesRelatedByRecipient->search($emailMessageRelatedByRecipient);
            $this->collEmailMessagesRelatedByRecipient->remove($pos);
            if (null === $this->emailMessagesRelatedByRecipientScheduledForDeletion) {
                $this->emailMessagesRelatedByRecipientScheduledForDeletion = clone $this->collEmailMessagesRelatedByRecipient;
                $this->emailMessagesRelatedByRecipientScheduledForDeletion->clear();
            }
            $this->emailMessagesRelatedByRecipientScheduledForDeletion[]= $emailMessageRelatedByRecipient;
            $emailMessageRelatedByRecipient->setRecipientEmailAddress(null);
        }

        return $this;
    }

    /**
     * Clears out the collEmailMessagesRelatedBySender collection
     *
     * This does not modify the database; however, it will remove any associated objects, causing
     * them to be refetched by subsequent calls to accessor method.
     *
     * @return void
     * @see        addEmailMessagesRelatedBySender()
     */
    public function clearEmailMessagesRelatedBySender()
    {
        $this->collEmailMessagesRelatedBySender = null; // important to set this to NULL since that means it is uninitialized
    }

    /**
     * Reset is the collEmailMessagesRelatedBySender collection loaded partially.
     */
    public function resetPartialEmailMessagesRelatedBySender($v = true)
    {
        $this->collEmailMessagesRelatedBySenderPartial = $v;
    }

    /**
     * Initializes the collEmailMessagesRelatedBySender collection.
     *
     * By default this just sets the collEmailMessagesRelatedBySender collection to an empty array (like clearcollEmailMessagesRelatedBySender());
     * however, you may wish to override this method in your stub class to provide setting appropriate
     * to your application -- for example, setting the initial array to the values stored in database.
     *
     * @param      boolean $overrideExisting If set to true, the method call initializes
     *                                        the collection even if it is not empty
     *
     * @return void
     */
    public function initEmailMessagesRelatedBySender($overrideExisting = true)
    {
        if (null !== $this->collEmailMessagesRelatedBySender && !$overrideExisting) {
            return;
        }
        $this->collEmailMessagesRelatedBySender = new ObjectCollection();
        $this->collEmailMessagesRelatedBySender->setModel('\Eater\Glim\Model\EmailMessage');
    }

    /**
     * Gets an array of ChildEmailMessage objects which contain a foreign key that references this object.
     *
     * If the $criteria is not null, it is used to always fetch the results from the database.
     * Otherwise the results are fetched from the database the first time, then cached.
     * Next time the same method is called without $criteria, the cached collection is returned.
     * If this ChildEmailAddress is new, it will return
     * an empty collection or the current collection; the criteria is ignored on a new object.
     *
     * @param      Criteria $criteria optional Criteria object to narrow the query
     * @param      ConnectionInterface $con optional connection object
     * @return ObjectCollection|ChildEmailMessage[] List of ChildEmailMessage objects
     * @throws PropelException
     */
    public function getEmailMessagesRelatedBySender(Criteria $criteria = null, ConnectionInterface $con = null)
    {
        $partial = $this->collEmailMessagesRelatedBySenderPartial && !$this->isNew();
        if (null === $this->collEmailMessagesRelatedBySender || null !== $criteria  || $partial) {
            if ($this->isNew() && null === $this->collEmailMessagesRelatedBySender) {
                // return empty collection
                $this->initEmailMessagesRelatedBySender();
            } else {
                $collEmailMessagesRelatedBySender = ChildEmailMessageQuery::create(null, $criteria)
                    ->filterBySenderEmailAddress($this)
                    ->find($con);

                if (null !== $criteria) {
                    if (false !== $this->collEmailMessagesRelatedBySenderPartial && count($collEmailMessagesRelatedBySender)) {
                        $this->initEmailMessagesRelatedBySender(false);

                        foreach ($collEmailMessagesRelatedBySender as $obj) {
                            if (false == $this->collEmailMessagesRelatedBySender->contains($obj)) {
                                $this->collEmailMessagesRelatedBySender->append($obj);
                            }
                        }

                        $this->collEmailMessagesRelatedBySenderPartial = true;
                    }

                    return $collEmailMessagesRelatedBySender;
                }

                if ($partial && $this->collEmailMessagesRelatedBySender) {
                    foreach ($this->collEmailMessagesRelatedBySender as $obj) {
                        if ($obj->isNew()) {
                            $collEmailMessagesRelatedBySender[] = $obj;
                        }
                    }
                }

                $this->collEmailMessagesRelatedBySender = $collEmailMessagesRelatedBySender;
                $this->collEmailMessagesRelatedBySenderPartial = false;
            }
        }

        return $this->collEmailMessagesRelatedBySender;
    }

    /**
     * Sets a collection of ChildEmailMessage objects related by a one-to-many relationship
     * to the current object.
     * It will also schedule objects for deletion based on a diff between old objects (aka persisted)
     * and new objects from the given Propel collection.
     *
     * @param      Collection $emailMessagesRelatedBySender A Propel collection.
     * @param      ConnectionInterface $con Optional connection object
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function setEmailMessagesRelatedBySender(Collection $emailMessagesRelatedBySender, ConnectionInterface $con = null)
    {
        /** @var ChildEmailMessage[] $emailMessagesRelatedBySenderToDelete */
        $emailMessagesRelatedBySenderToDelete = $this->getEmailMessagesRelatedBySender(new Criteria(), $con)->diff($emailMessagesRelatedBySender);


        $this->emailMessagesRelatedBySenderScheduledForDeletion = $emailMessagesRelatedBySenderToDelete;

        foreach ($emailMessagesRelatedBySenderToDelete as $emailMessageRelatedBySenderRemoved) {
            $emailMessageRelatedBySenderRemoved->setSenderEmailAddress(null);
        }

        $this->collEmailMessagesRelatedBySender = null;
        foreach ($emailMessagesRelatedBySender as $emailMessageRelatedBySender) {
            $this->addEmailMessageRelatedBySender($emailMessageRelatedBySender);
        }

        $this->collEmailMessagesRelatedBySender = $emailMessagesRelatedBySender;
        $this->collEmailMessagesRelatedBySenderPartial = false;

        return $this;
    }

    /**
     * Returns the number of related EmailMessage objects.
     *
     * @param      Criteria $criteria
     * @param      boolean $distinct
     * @param      ConnectionInterface $con
     * @return int             Count of related EmailMessage objects.
     * @throws PropelException
     */
    public function countEmailMessagesRelatedBySender(Criteria $criteria = null, $distinct = false, ConnectionInterface $con = null)
    {
        $partial = $this->collEmailMessagesRelatedBySenderPartial && !$this->isNew();
        if (null === $this->collEmailMessagesRelatedBySender || null !== $criteria || $partial) {
            if ($this->isNew() && null === $this->collEmailMessagesRelatedBySender) {
                return 0;
            }

            if ($partial && !$criteria) {
                return count($this->getEmailMessagesRelatedBySender());
            }

            $query = ChildEmailMessageQuery::create(null, $criteria);
            if ($distinct) {
                $query->distinct();
            }

            return $query
                ->filterBySenderEmailAddress($this)
                ->count($con);
        }

        return count($this->collEmailMessagesRelatedBySender);
    }

    /**
     * Method called to associate a ChildEmailMessage object to this object
     * through the ChildEmailMessage foreign key attribute.
     *
     * @param  ChildEmailMessage $l ChildEmailMessage
     * @return $this|\Eater\Glim\Model\EmailAddress The current object (for fluent API support)
     */
    public function addEmailMessageRelatedBySender(ChildEmailMessage $l)
    {
        if ($this->collEmailMessagesRelatedBySender === null) {
            $this->initEmailMessagesRelatedBySender();
            $this->collEmailMessagesRelatedBySenderPartial = true;
        }

        if (!$this->collEmailMessagesRelatedBySender->contains($l)) {
            $this->doAddEmailMessageRelatedBySender($l);
        }

        return $this;
    }

    /**
     * @param ChildEmailMessage $emailMessageRelatedBySender The ChildEmailMessage object to add.
     */
    protected function doAddEmailMessageRelatedBySender(ChildEmailMessage $emailMessageRelatedBySender)
    {
        $this->collEmailMessagesRelatedBySender[]= $emailMessageRelatedBySender;
        $emailMessageRelatedBySender->setSenderEmailAddress($this);
    }

    /**
     * @param  ChildEmailMessage $emailMessageRelatedBySender The ChildEmailMessage object to remove.
     * @return $this|ChildEmailAddress The current object (for fluent API support)
     */
    public function removeEmailMessageRelatedBySender(ChildEmailMessage $emailMessageRelatedBySender)
    {
        if ($this->getEmailMessagesRelatedBySender()->contains($emailMessageRelatedBySender)) {
            $pos = $this->collEmailMessagesRelatedBySender->search($emailMessageRelatedBySender);
            $this->collEmailMessagesRelatedBySender->remove($pos);
            if (null === $this->emailMessagesRelatedBySenderScheduledForDeletion) {
                $this->emailMessagesRelatedBySenderScheduledForDeletion = clone $this->collEmailMessagesRelatedBySender;
                $this->emailMessagesRelatedBySenderScheduledForDeletion->clear();
            }
            $this->emailMessagesRelatedBySenderScheduledForDeletion[]= $emailMessageRelatedBySender;
            $emailMessageRelatedBySender->setSenderEmailAddress(null);
        }

        return $this;
    }

    /**
     * Clears the current object, sets all attributes to their default values and removes
     * outgoing references as well as back-references (from other objects to this one. Results probably in a database
     * change of those foreign objects when you call `save` there).
     */
    public function clear()
    {
        if (null !== $this->aUserRelatedByOwner) {
            $this->aUserRelatedByOwner->removeEmailAddressRelatedByOwner($this);
        }
        $this->id = null;
        $this->verified = null;
        $this->verification = null;
        $this->address = null;
        $this->owner = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references and back-references to other model objects or collections of model objects.
     *
     * This method is used to reset all php object references (not the actual reference in the database).
     * Necessary for object serialisation.
     *
     * @param      boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep) {
            if ($this->collUsersRelatedByEmail) {
                foreach ($this->collUsersRelatedByEmail as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collEmailMessagesRelatedByRecipient) {
                foreach ($this->collEmailMessagesRelatedByRecipient as $o) {
                    $o->clearAllReferences($deep);
                }
            }
            if ($this->collEmailMessagesRelatedBySender) {
                foreach ($this->collEmailMessagesRelatedBySender as $o) {
                    $o->clearAllReferences($deep);
                }
            }
        } // if ($deep)

        $this->collUsersRelatedByEmail = null;
        $this->collEmailMessagesRelatedByRecipient = null;
        $this->collEmailMessagesRelatedBySender = null;
        $this->aUserRelatedByOwner = null;
    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(EmailAddressTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preSave(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface $con
     */
    public function postSave(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before inserting to database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preInsert(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface $con
     */
    public function postInsert(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before updating the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preUpdate(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface $con
     */
    public function postUpdate(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before deleting the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preDelete(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface $con
     */
    public function postDelete(ConnectionInterface $con = null)
    {

    }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed  $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);

            return $this->importFrom($format, reset($params));
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = isset($params[0]) ? $params[0] : true;

            return $this->exportTo($format, $includeLazyLoadColumns);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
